import { Component, OnInit } from '@angular/core';
import { Router } from '@angular/router';
import { AuthService } from '../services/auth.service';

@Component({
  selector: 'app-login',
  templateUrl: './login.component.html',
  styleUrls: ['./login.component.scss']
})
export class LoginComponent implements OnInit {
  email: string;
  password: string;
  errorMessage: string;

  constructor(
    private authService: AuthService,
    private router: Router
  ) { }

  ngOnInit(): void {
    if (this.authService.authenticated) {
      this.redirectToMainPage();
    }
  }

  login() {
    this.authService.signIn(this.email, this.password,
      () => {
        this.redirectToMainPage();
      },
      (err) => {
        this.errorMessage = err;
      });
  }

  redirectToMainPage() {
    this.router.navigate(['/prehled']);
  }
}
