#ifndef __ENV_MONITOR_H__
#define __ENV_MONITOR_H__

#include "esp_err.h"
#include "firestore.h"

#define TPS_PS_EN_GPIO  26

typedef enum {
  ENV_MONITOR_WAKEUP_UNDEFINED,
  ENV_MONITOR_WAKEUP_TIMER,
  ENV_MONITOR_WAKEUP_GPIO34,
  ENV_MONITOR_WAKEUP_GPIO35
} env_monitor_wakeup_t;

void env_monitor_get_mac_id(void);

void env_monitor_set_default_settings(void);

void env_monitor_voc_init(void);

void env_monitor_check_tasks(void);

void env_monitor_set_default_tasks_time(void);

bool env_monitor_measure_task_ticked(void);

bool env_monitor_send_task_ticked(void);

bool env_monitor_battery_measure_task_ticked(void);

bool env_monitor_voc_algorithm_task_ticked(void);

bool env_monitor_is_initialized(void);

bool env_monitor_get_sntp_retry_next(void);

void env_monitor_set_sntp_retry_next(bool retry_next);

bool env_monitor_get_load_settings_retry_next(void);

void env_monitor_set_load_settings_retry_next(bool retry_next);

bool env_monitor_get_sntp_sync_time_flag(void);

void env_monitor_sleep_start(void);

int env_monitor_count_sleep_time_sec(void);

env_monitor_wakeup_t env_monitor_get_wakeup_cause(void);

esp_err_t env_monitor_load_settings(void);

int16_t env_monitor_process_voc_algorithm(void);

esp_err_t env_monitor_measure_data(void);

firestore_err_t env_monitor_send_data(void);

firestore_err_t env_monitor_send_data_from_buff(void);

void env_monitor_add_data_to_buff(void);

void env_monitor_check_battery(void);

esp_err_t env_monitor_start_diagnostics(void);

esp_err_t env_monitor_enable_tps_power_save_mode(void);

esp_err_t env_monitor_disable_tps_power_save_mode(void);

#endif /* __ENV_MONITOR_H__ */