#ifndef __SENSORS_H__
#define __SENSORS_H__

#define SCD30_ADDRESS       0x61
#define SCD30_PWREN_GPIO    4
#define SCD30_PWM           13
#define SCD30_RDY           14
#define I2C_SCD30_SDA_GPIO  17
#define I2C_SCD30_SCL_GPIO  16

#include "driver/i2c.h"

esp_err_t sens_i2c0_init(void);

esp_err_t sens_i2c1_init(void);

bool sens_get_i2c0_initialized(void);

bool sens_get_i2c1_initialized(void);

esp_err_t sens_i2c_write(i2c_port_t i2c_num, uint8_t addr, uint8_t *data, uint16_t data_len);

esp_err_t sens_i2c_write_byte_to_reg(i2c_port_t i2c_num, uint8_t sens_addr, uint8_t sens_reg_addr, uint8_t data);

esp_err_t sens_i2c_read(i2c_port_t i2c_num, uint8_t addr, uint8_t *data, uint16_t data_len);

esp_err_t sens_i2c_read_from_reg(i2c_port_t i2c_num, uint8_t sens_addr, uint8_t sens_reg_addr, uint8_t *data, uint16_t data_len);

int16_t sens_scd30_init(void);

void sens_scd30_stop(void);

#endif /* __SENSORS_H__ */